# Generated by Django 3.2.5 on 2024-02-22 13:43

from django.db import migrations


class Migration(migrations.Migration):

    dependencies = [
        ('sgpa', '0008_auto_20240229_1103'),
    ]

    operations = [
        migrations.RunSQL(
            """
            CREATE OR REPLACE VIEW public.view_tree_kind AS
            WITH RECURSIVE tree_kind_r AS (
                SELECT id, common_name, label, parent_id, 0 AS level FROM sgpa_treekind WHERE parent_id IS NULL
                UNION
                SELECT sgpa_treekind.id, sgpa_treekind.common_name, tree_kind_r.label || ' ' || sgpa_treekind.label, sgpa_treekind.parent_id, tree_kind_r.level + 1 FROM sgpa_treekind
                    JOIN tree_kind_r ON sgpa_treekind.parent_id = tree_kind_r.id
            )
            SELECT * FROM tree_kind_r
            """,
            reverse_sql="DROP VIEW IF EXISTS public.view_tree_kind"
        ),
        migrations.RunSQL(
            """
            CREATE OR REPLACE VIEW public.view_trees AS
            SELECT
                t.id,
                t.point,
                st_astext(t.point) AS point_wkt,
                park.name->>'fr' AS "park name FR",
                park.name->>'nl' AS "park name NL",
                park.trigramme,
                tree_kind.label AS "essence",
                tree_kind.common_name->>'fr' AS "species_common_name_FR",
                tree_kind.common_name->>'nl' AS "common_name_NL",
                sgpa_treestatus.label->>'fr' AS "status_FR",
                sgpa_treestatus.label->>'nl' AS "status_NL",
                sgpa_treedendrometryhistory.circumference150 AS "c150_cm",
                sgpa_treedendrometryhistory.height AS "h_tot_m",
                sgpa_treedendrometryhistory.crown_diameter_range AS "d_cour_m",
                sgpa_treedendrometryhistory.branches_count AS "nb_brins",
                sgpa_treeontogenesishistory.ontogenesis AS ontogenese,
                sgpa_treestructure.label->>'fr' AS "structure_FR",
                sgpa_treestructure.label->>'nl' AS "structure_NL",
                sgpa_tree_environment_sq."envi_FR",
                sgpa_tree_environment_sq."envi_NL",
                sgpa_treesymptomroothistory_sq."FR" AS sympt_raci_FR,
                sgpa_treesymptomroothistory_sq."NL" AS sympt_raci_NL,
                sgpa_treesymptomcollarhistory_sq."FR" AS sympt_coll_FR,
                sgpa_treesymptomcollarhistory_sq."NL" AS sympt_coll_NL,
                sgpa_treesymptomtrunkhistory_sq."FR" AS sympt_tron_FR,
                sgpa_treesymptomtrunkhistory_sq."NL" AS sympt_tron_NL,
                sgpa_treesymptombranchhistory_sq."FR" AS sympt_bran_FR,
                sgpa_treesymptombranchhistory_sq."NL" AS sympt_bran_NL,
                sgpa_treesymptomleavehistory_sq."FR" AS sympt_feuil_FR,
                sgpa_treesymptomleavehistory_sq."NL" AS sympt_feuil_NL,
                tree_pathogen."FR" AS "pathogene_FR",
                tree_pathogen."NL" AS "pathogene_NL",
                tree_pest."FR" AS "ravageur_FR",
                tree_pest."NL" AS "ravageur_NL",
                tree_epithyte."FR" AS "epiphyte_FR",
                tree_epithyte."NL" AS "epithyte_NL",
                sgpa_treevitalityhistory.vitality AS "etat_sanit",
                sgpa_treeriskanalysishistory.break_risk AS "secu_risq",
                sgpa_treeriskanalysishistory.size_risk AS "secu_calib",
                sgpa_treeriskanalysishistory.target_risk AS "secu_cibl",
                sgpa_treeriskanalysishistory.break_risk
                    + sgpa_treeriskanalysishistory.size_risk
                    + sgpa_treeriskanalysishistory.target_risk AS "secu_dang"
            FROM sgpa_tree AS t
            LEFT JOIN sgpa_park AS park ON ST_contains(park.multipolygon, t.point)
            JOIN view_tree_kind AS tree_kind ON t.kind_id = tree_kind.id
            LEFT JOIN sgpa_treestatushistory ON t.id = sgpa_treestatushistory.tree_id AND sgpa_treestatushistory.validity @> CURRENT_DATE
            LEFT JOIN sgpa_treestatus ON sgpa_treestatushistory.status_id = sgpa_treestatus.id
            LEFT JOIN sgpa_treedendrometryhistory ON t.id = sgpa_treedendrometryhistory.tree_id AND sgpa_treedendrometryhistory.validity @> CURRENT_DATE
            LEFT JOIN public.sgpa_treeontogenesishistory ON t.id = sgpa_treeontogenesishistory.tree_id AND sgpa_treeontogenesishistory.validity @> CURRENT_DATE
            LEFT JOIN sgpa_treestructurehistory ON t.id = sgpa_treestructurehistory.tree_id AND sgpa_treestructurehistory.validity @> CURRENT_DATE
            LEFT JOIN sgpa_treestructure ON sgpa_treestructurehistory.structure_id = sgpa_treestructure.id
            LEFT JOIN (
                    SELECT
                        string_agg(sgpa_treeenvironment.label->>'fr', ', ' order by sgpa_treeenvironment.label->>'fr') AS "envi_FR",
                        string_agg(sgpa_treeenvironment.label->>'nl', ', ' order by sgpa_treeenvironment.label->>'nl') AS "envi_NL",
                        sgpa_treeenvironmenthistory.tree_id
                    FROM sgpa_treeenvironmenthistory
                         LEFT JOIN sgpa_treeenvironmenthistory_environments ON sgpa_treeenvironmenthistory.id = sgpa_treeenvironmenthistory_environments.treeenvironmenthistory_id
                         LEFT JOIN sgpa_treeenvironment ON sgpa_treeenvironmenthistory_environments.treeenvironment_id = sgpa_treeenvironment.id
                    GROUP BY sgpa_treeenvironmenthistory.tree_id
                ) AS sgpa_tree_environment_sq ON sgpa_tree_environment_sq.tree_id = t.id
            LEFT JOIN (
                SELECT
                    string_agg(symptoms.label->>'fr', ', ' order by symptoms.label->>'fr') AS "FR",
                    string_agg(symptoms.label->>'nl', ', ' order by symptoms.label->>'nl') AS "NL",
                    sh.tree_id
                FROM sgpa_treesymptomroothistory sh
                    LEFT JOIN sgpa_treesymptomroothistory_symptoms sh_symptoms ON sh.id = sh_symptoms.treesymptomroothistory_id
                    LEFT JOIN sgpa_treesymptomroot symptoms ON sh_symptoms.treesymptomroot_id = symptoms.id
                GROUP BY sh.tree_id
            ) AS sgpa_treesymptomroothistory_sq ON sgpa_treesymptomroothistory_sq.tree_id = t.id
            LEFT JOIN (
                SELECT
                    string_agg(symptoms.label->>'fr', ', ' order by symptoms.label->>'fr') AS "FR",
                    string_agg(symptoms.label->>'nl', ', ' order by symptoms.label->>'nl') AS "NL",
                    sh.tree_id
                FROM sgpa_treesymptomcollarhistory sh
                         LEFT JOIN sgpa_treesymptomcollarhistory_symptoms sh_symptoms ON sh.id = sh_symptoms.treesymptomcollarhistory_id
                         LEFT JOIN sgpa_treesymptomcollar symptoms ON sh_symptoms.treesymptomcollar_id = symptoms.id
                GROUP BY sh.tree_id
            ) AS sgpa_treesymptomcollarhistory_sq ON sgpa_treesymptomcollarhistory_sq.tree_id = t.id
            LEFT JOIN (
                SELECT
                    string_agg(symptoms.label->>'fr', ', ' order by symptoms.label->>'fr') AS "FR",
                    string_agg(symptoms.label->>'nl', ', ' order by symptoms.label->>'nl') AS "NL",
                    sh.tree_id
                FROM sgpa_treesymptombranchhistory sh
                         LEFT JOIN sgpa_treesymptombranchhistory_symptoms sh_symptoms ON sh.id = sh_symptoms.treesymptombranchhistory_id
                         LEFT JOIN sgpa_treesymptombranch symptoms ON sh_symptoms.treesymptombranch_id = symptoms.id
                GROUP BY sh.tree_id
            ) AS sgpa_treesymptombranchhistory_sq ON sgpa_treesymptombranchhistory_sq.tree_id = t.id
            LEFT JOIN (
                SELECT
                    string_agg(symptoms.label->>'fr', ', ' order by symptoms.label->>'fr') AS "FR",
                    string_agg(symptoms.label->>'nl', ', ' order by symptoms.label->>'nl') AS "NL",
                    sh.tree_id
                FROM sgpa_treesymptomtrunkhistory sh
                         LEFT JOIN sgpa_treesymptomtrunkhistory_symptoms sh_symptoms ON sh.id = sh_symptoms.treesymptomtrunkhistory_id
                         LEFT JOIN sgpa_treesymptomtrunk symptoms ON sh_symptoms.treesymptomtrunk_id = symptoms.id
                GROUP BY sh.tree_id
            ) AS sgpa_treesymptomtrunkhistory_sq ON sgpa_treesymptomtrunkhistory_sq.tree_id = t.id
            LEFT JOIN (
                SELECT
                    string_agg(symptoms.label->>'fr', ', ' order by symptoms.label->>'fr') AS "FR",
                    string_agg(symptoms.label->>'nl', ', ' order by symptoms.label->>'nl') AS "NL",
                    sh.tree_id
                FROM sgpa_treesymptomleavehistory sh
                         LEFT JOIN sgpa_treesymptomleavehistory_symptoms sh_symptoms ON sh.id = sh_symptoms.treesymptomleavehistory_id
                         LEFT JOIN sgpa_treesymptomleave symptoms ON sh_symptoms.treesymptomleave_id = symptoms.id
                GROUP BY sh.tree_id
            ) AS sgpa_treesymptomleavehistory_sq ON sgpa_treesymptomleavehistory_sq.tree_id = t.id
            LEFT JOIN (
                SELECT
                    string_agg(p.label->>'fr', ', ' order by p.label->>'fr') AS "FR",
                    string_agg(p.label->>'nl', ', ' order by p.label->>'nl') AS "NL",
                    ph.tree_id
                FROM sgpa_treepathogenhistory ph
                LEFT JOIN sgpa_treepathogenhistory_pathogens pp ON ph.id = pp.treepathogenhistory_id
                LEFT JOIN sgpa_treepathogen p ON pp.treepathogen_id = p.id
                GROUP BY ph.tree_id
            ) AS tree_pathogen ON tree_pathogen.tree_id = t.id
            LEFT JOIN (
                SELECT
                    string_agg(p.label->>'fr', ', ' order by p.label->>'fr') AS "FR",
                    string_agg(p.label->>'nl', ', ' order by p.label->>'nl') AS "NL",
                    ph.tree_id
                FROM sgpa_treeepiphytehistory ph
                         LEFT JOIN sgpa_treeepiphytehistory_epiphytes pp ON ph.id = pp.treeepiphytehistory_id
                         LEFT JOIN sgpa_treeepiphyte p ON pp.treeepiphyte_id = p.id
                GROUP BY ph.tree_id
            ) AS tree_epithyte ON tree_epithyte.tree_id = t.id
            LEFT JOIN (
                SELECT
                    string_agg(p.label->>'fr', ', ' order by p.label->>'fr') AS "FR",
                    string_agg(p.label->>'nl', ', ' order by p.label->>'nl') AS "NL",
                    ph.tree_id
                FROM sgpa_treepesthistory ph
                         LEFT JOIN sgpa_treepesthistory_pests pp ON ph.id = pp.treepesthistory_id
                         LEFT JOIN sgpa_treepest p ON pp.treepest_id = p.id
                GROUP BY ph.tree_id
            ) AS tree_pest ON tree_pest.tree_id = t.id
            LEFT JOIN sgpa_treevitalityhistory ON t.id = sgpa_treevitalityhistory.tree_id AND sgpa_treevitalityhistory.validity @> CURRENT_DATE
            LEFT JOIN sgpa_treeriskanalysishistory ON t.id = sgpa_treeriskanalysishistory.tree_id;
            """,
            reverse_sql="DROP VIEW IF EXISTS public.view_trees"
        )
    ]
